/* Square functions */

#ifndef __SQUARE_H__
#define __SQUARE_H__

#include <stdio.h>

// Square struct
// basic building block of the game
typedef struct {
	int m_Size;				// width & height of the square
	VECTOR *m_Color1;		// color of the square
	VECTOR *m_Color2;		// color of the square
	VECTOR *m_Location;	// x, y location of the square
} Square;

// Create square
Square *square_new()
{
	Square *square;
	square = (Square *)malloc(sizeof(Square));
	
	// Init size
	square->m_Size = 16;
	
	square->m_Color1 = (VECTOR *)malloc(sizeof(VECTOR));
	square->m_Color2 = (VECTOR *)malloc(sizeof(VECTOR));
	square->m_Location = (VECTOR *)malloc(sizeof(VECTOR));
	
	// Initialisation
	vec_set( square->m_Color1, nullvector );
	vec_set( square->m_Color2, nullvector );
	vec_set( square->m_Location, nullvector );
	
	return square;
}

// Create square
Square *square_new(int size, VECTOR *color1, VECTOR *color2, VECTOR *location)
{
	Square *square = square_new();
	
	square->m_Size = size;
	vec_set( square->m_Color1, color1 );
	vec_set( square->m_Color2, color2 );
	vec_set( square->m_Location, location );
	
	return square;
}


// Free resource
void square_delete(Square *square)
{
	free(square);
}

// Draw square
void square_draw(Square *square)
{
	// controur
	draw_quad(NULL, square->m_Location, NULL, vector(square->m_Size, square->m_Size, 0), NULL, vector(0, 0, 0), 100, 0);
	draw_quad(NULL, square->m_Location, NULL, vector(square->m_Size, square->m_Size / 2, 0), NULL, vector(0x66, 0x66, 0x66), 100, 0);
	// remplissage
	draw_quad( NULL, vector(square->m_Location.x + 1, square->m_Location.y + 1, 0), NULL, vector(square->m_Size - 2, square->m_Size - 2, 0), NULL, square->m_Color1, 100, 0);
	draw_quad( NULL, vector(square->m_Location.x + 1, square->m_Location.y + 1, 0), NULL, vector(square->m_Size - 2, square->m_Size / 2, 0), NULL, square->m_Color2, 100, 0);
}

// __SQUARE_H__
#endif